
/*
 *  header - $Id: internal.h,v 1.4 1997/06/11 21:39:52 qian Exp $
 *
 *  internel API of the memory-based guard tool
 */


/*********************************************************************
types & constants
*********************************************************************/

/* refer to "include/memguard/memguard_internal.h" */


/*********************************************************************
variables
*********************************************************************/

/* refer to "include/memguard/memguard_internal.h" */

/*
 * Variables  : mgNinvariant
 *              mgInvariants
 *              mgInvariantsFree
 * Description: information of invariants
 */
/* the number of control blocks of invariants */
extern u_int mgNinvariant;

/* an allocated array of control blocks of invariants */
extern mginvariant_t *mgInvariants;

/* a free list of control blocks of invariants */
extern mginvariant_t *mgInvariantsFree;

/*
 * Variables  : mgNregion
 *              mgRegions
 *              mgIndexRegion
 * Description: information of guarded regions
 */
/* the number of control blocks of regions */
extern u_int mgNregion;

/* an allocated array of control blocks of guarded regions */
extern mgregion_t *mgRegions;

/* the current free index of the control blocks of guarded regions */
extern u_int mgIndexRegion;

/*
 * Variables  : mgErrno
 * Description: the error number for the internal use
 */
/* the error number for the internal use */
extern int mgErrno;


/*********************************************************************
functions
*********************************************************************/

/* refer to "include/memguard/memguard_internal.h" */

/* reset data structures */
extern void mgResetDS(void);

/* get page with virtual address in */
extern mgpage_t *mgGetPage(caddr_t vaddr, u_int size);
/*  #define MG_GETPAGE_SUCCESS	pointer to the corresponding page */
/*  #define MG_GETPAGE_FAIL	NULL */
    /* mgErrno */
#    define MG_GETPAGE_VADDR	1	/* invalid virtual address */
#    define MG_GETPAGE_SIZE	2	/* invalid size */

