
/*
 *  header - $Id: macros.h,v 1.3 1997/06/10 19:12:26 qian Exp $
 *
 *  macros of the memory-based guard tool
 */


/*********************************************************************
types & constants
*********************************************************************/

/*
 * Types/Consts: mgAddr2Pageno
 *               mgPageno2Addr
 *               mgNpage2Nbyte
 *               mgNbyte2Npage
 *               mgAlignStartAddr
 *               mgAlignEndAddr
 *               mgAddr2Offset
 *               mgOffset2Addr
 *               mgOffsetIncr
 *               mgAddrLen2nPage
 * Description : information of pages
 */
/* address to page number */
#define mgAddr2Pageno(addr)	((int)(addr) / MG_SZPAGE)

/* page number to address */
#define mgPageno2Addr(pn)	((caddr_t)((pn) * MG_SZPAGE))

/* number of pages to number of bytes */
#define mgNpage2Nbyte(npage)	((npage) * MG_SZPAGE)

/* number of bytes to number of pages */
#define mgNbyte2Npage(nbyte)	(((nbyte) + (MG_SZPAGE-1)) / MG_SZPAGE)

/* align address to start of this page */
#define mgAlignStartAddr(addr)	mgPageno2Addr(mgAddr2Pageno(addr))

/* align address to EXCLUSIVE end of this page */
#define mgAlignEndAddr(addr)	mgPageno2Addr(mgNbyte2Npage((u_int)addr))

/* address to offset */
#define mgAddr2Offset(addr)	((u_short)((u_int)(addr) % MG_SZPAGE))

/* offset to address */
#define mgOffset2Addr(pn,off)	((caddr_t)(mgPageno2Addr(pn) + (off)))

/* increase offset */
#define mgOffsetIncr(off,incr)		{\
		(off) += (incr);	\
		(off) %= MG_SZPAGE;	}

/* address & length to number of pages */
#define mgAddrLen2nPage(addr,len)	\
        ((mgAddr2Offset(addr) + (len) + (MG_SZPAGE - 1)) / MG_SZPAGE)


/*********************************************************************
variables
*********************************************************************/


/*********************************************************************
functions
*********************************************************************/

