
/*
 *  header - $Id: types.h,v 1.2 1997/06/10 18:49:27 qian Exp $
 *
 *  types of memory-based guard tool
 */


/*********************************************************************
types & constants
*********************************************************************/

/*
 * Types/Consts: NULL
 * Description : NULL
 */
#ifndef NULL
#define NULL	0
#endif

/*
 * Types/Consts: mginvariant_t
 * Description : information of invariants
 */
/* size of invariant name */
#define MG_SZNAME 20

/* control block of an invariant */
typedef struct _mginvariant_t {
    struct _mginvariant_t *gi_next;	/* next in same page */

    u_short gi_offset;			/* offset in page */
    u_short gi_length;			/* length in page */
    u_int   gi_size;			/* invariant length */
	 /* NOTE: equal to ZERO if not the first part of invariant */

    char    gi_name[MG_SZNAME];		/* invariant name */
} mginvariant_t;

/*
 * Types/Consts: mgpage_t
 * Description : information of guarded pages
 */
/* control block of a page */
typedef struct _mgpage_t {
    unsigned char  gp_prot;	/* original page protection */
        #define MG_RDONLY	0	/* read-only */
        #define MG_RDWR		1	/* read-write */
    mginvariant_t *gp_invariants;
	/* pointer to the invariant control block list of this page */
} mgpage_t;

/*
 * Types/Consts: mgregion_t
 * Description : information of guarded regions
 */
/* control block of a region */
typedef struct _mgregion_t {
    caddr_t   gr_svaddr;/* start virtual address of pages */
    caddr_t   gr_evaddr;/* (EXCLUSIVE) end virtual address of pages */

    mgpage_t *gr_pages;	/* pointer to page table of this region */
    u_int     gr_npage;	/* number of memguard pages in this region */
} mgregion_t;


/*********************************************************************
variables
*********************************************************************/


/*********************************************************************
functions
*********************************************************************/

